/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*import scheduledbbackup.**/
import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.TimerTask;

/**
 *
 * @author YaraGo
 */
public class YaraGoDBBackUps extends TimerTask {

	/**
	 * @param args the command line arguments
	 **/

	/**
	 * 
	 * @param hostName
	 *            - Name of the Host where the DB is residing
	 * @param dbName
	 *            - Target database schema for which the backup needs to be taken
	 * @param dbUser
	 *            - Database user name, basically authorized user
	 * @param dbPass
	 *            - Password to access the above mentioned user account
	 * @param dbFileLocation
	 *            - Relative path of the database backup file C:\Program
	 *            Files\MySQL\MySQL Server 5.6\bin>mysqldump -u root -p
	 *            --add-drop-data base --databases yghealthcarecombined -h
	 *            192.168.0.115 -P 3306 --routines -r D:\
	 *            ygemrdbBackup\ygemrdbbkp.sql
	 * @return
	 */
	private static String globalFolderName = "";
	private static String globalSchemaName = "";
	private static String globalDbIP = "";
	private static String globalUsername = "";
	private static String globalPassword = "";
	private static String globalOsIdentifier = "";

	public static void main(String[] args) {

		YaraGoDBBackUps dbBackup = new YaraGoDBBackUps();
		globalFolderName = args[0];
		globalSchemaName = args[1];
		globalDbIP = args[2];
		globalUsername = args[3];
		globalPassword = args[4];
		globalOsIdentifier = args[5];
		dbBackup.run();
	}

	@SuppressWarnings("finally")
	public static String doGetDatabaseBackup(String hostName, String dbName, String dbUser, String dbPass,
			String dbFileLocation) {

		String message = "Could not take mysql backup";

		try {
			String executeCmd = "";
			if (globalOsIdentifier.equals("WIN")) {
				executeCmd = "C:\\Program Files\\MySQL\\MySQL Server 5.6\\bin\\mysqldump -u " + dbUser + " -p" + dbPass
						+ " --add-drop-database --databases " + dbName + " -h " + hostName + " -P 3306"
						+ " --routines -r " + dbFileLocation;
			} else if (globalOsIdentifier.equals("UBU")) {
				executeCmd = "mysqldump -u " + dbUser + " -p" + dbPass + " --add-drop-database --databases " + dbName
						+ " -h " + hostName + " -P 3306" + " --routines -r " + dbFileLocation;
			}
			System.out.println("Backup Command = " + executeCmd);
			Process runtimeProcess = Runtime.getRuntime().exec(executeCmd);
			int processComplete = runtimeProcess.waitFor();
			if (processComplete == 0) {
				message = "Backup taken successfully";
			} else {
				message = "Could not take mysql backup";
			}
		} catch (IOException e) {
			System.out.println("@@IOException occurred while generating the DB Backup file");
		} catch (InterruptedException e) {
			System.out.println("@@InterruptedException occurred while generating the DB Backup file");
		} finally {
			return message;
		}

	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		String dbBackUpPath = globalFolderName + "/" ;//+ globalSchemaName + "_" + new Date().getTime();
		File f1 = new File(dbBackUpPath);
		File f = new File(dbBackUpPath + globalSchemaName+"_"+new Date().getTime() + ".sql");
		if (f1.exists()) {
			//System.out.println(f1.mkdir());
			/*f1.mkdirs();
			try {
				f1.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}*/
			String msg = doGetDatabaseBackup(globalDbIP, globalSchemaName, globalUsername, globalPassword, "" + f + "");
			System.out.println("@@Msg = " + msg);
		}/* else {
			String msg = doGetDatabaseBackup(globalDbIP, globalSchemaName, globalUsername, globalPassword, "" + f + "");
			System.out.println("@@Msg = " + msg);
		} */

	}
	/*
	 * D:\BatchTest>java YaraGoDBBackUps  D:\\BatchTest\\YGEMRDBBACKUP\\OPHTHAL ophthalstock 192.168.0.200 root yarago123 WIN
	 */
}
